Program Landscape3D;

Uses
  Crt,Graph;

Const
  minzoom:integer = 100;
  maxzoom:integer = 200;
  HilfeDatei = 'Hilfe.TXT';
  ZoomZ: word = 200;
  GridBreite = 100;
  GridLengs = 100;
  MaxGrid = GridBreite*GridLengs;
  MaxFace = (GridBreite-1)*(GridLengs-1)*2;
  mode_verschieben = 0;
  mode_drehen = 1;
  mode_selecten = 2;
  status: array[0..2] of string = ('Editieren','Drehen/Skalieren','Vertex editieren');
  MulFaktor = 512;

Type
  Sack = Array[1..gridbreite,1..gridlengs] Of Real;
  Sack2 = Array[1..gridbreite,1..gridlengs] Of Record
    x,y:Integer;
  End;
  Sack3 = Array[1..gridbreite,1..gridlengs] Of Boolean;
  Sack4 = Record x,y:Integer; End;

var
  Gleichzeitig: Boolean;
  IncNext_Str,DecFactor_Str: String;
  IncNext,DecFactor: Real;
  gridwidth, gridheight: byte;
  GenauigkeitderParabel:Real;
  plus_minus: boolean;
  Follow_On: Boolean;
  UserX,UserY: Byte;
  lines: boolean;
  AP,VP: Integer;
  ch: char;
  mode: byte;
  Feld: ^Sack;
  Bild: ^Sack2;
  breiteX,BreiteZ: real;
  Vx,vy,vz: real;
  Select: ^Sack3;
  xySelect: Sack4;
  rotx,roty,rotz: integer;
  FixSin: array[0..360] of longint;
  FixCos: array[0..360] of longint;

function real2fix(_real: real): longint;
begin
     real2fix:=round(_real * mulfaktor);
end;

function fix2real(_fix: longint): real;
begin
     fix2real:=_fix / mulfaktor;
end;

function FixMul(A,B :longint) :longint; near; external;
function FixDiv(A,B :longint) :longint; near; external;
{$L fixed}

Procedure DelKeyBuffer;
Var
  D: Char;
Begin
  Repeat
    If Keypressed then D:=ReadKey;
  Until not Keypressed;
End;

Procedure InitVGA;
Var
  GDrive,GMode,Code: Integer;
  GPath: String;
Begin
  GDrive:=9; GMode:=1; GPath:='';
  InitGraph(GDrive,GMode,GPath);
  Code := GraphResult;
  If Code <> 0 then halt(2);
  SetVisualpage(0);
  SetActivePage(0);
  AP:=0;
  VP:=0;
End;

Procedure SwapVP;
Begin
     If VP = 1 then
     Begin
        SetVisualPage(0);
        VP := 0;
     End
     Else
     Begin
         SetVisualPage(1);
         VP := 1;
     End;
End;

Procedure SwapAP;
Begin
     If AP = 1 then
     Begin
        SetActivePage(0);
        AP := 0;
     End
     Else
     Begin
         SetActivePage(1);
         AP := 1;
     End;
End;

procedure make_tabelle;
var
   i: word;
begin
     for i:=0 to 360 do begin
         fixsin[i]:=real2fix(sin((pi/180)*i));
         fixcos[i]:=real2fix(cos((pi/180)*i));
     end;
end;

FUNCTION Stri(Zahl:Longint):STRING;
   VAR
      tmp:STRING;
   BEGIN
      str(Zahl,tmp);
      stri:=tmp;
   END;

Procedure Unselect;
  Var
    a,b:Integer;

  Begin
    For a:=1 To GridHeight Do
      For b:=1 To GridWidth Do
        Select^[a,b]:=False;
  End;

Procedure SelectAll;
  Var
    a,b:Integer;

  Begin
    For a:=1 To GridHeight Do
      For b:=1 To GridWidth Do
        Select^[a,b]:=True;
  End;

Procedure Init_Mode12h;
  Var
    grDriver: Integer;
    grMode:   Integer;
    ErrCode:  Integer;

  Begin
    grDriver := Detect;
    InitGraph(grDriver, grMode,'');
    ErrCode := GraphResult;
    If ErrCode <> grOk Then Begin
      Writeln('Graphics error:', GraphErrorMsg(ErrCode));
      Halt(2);
    End;
  End;

Procedure LeaveVGA;
  Begin
    Closegraph;
    Writeln('Danke!');
  End;

Procedure Male_Feld(rotx,roty,rotz: integer;MaleVert:Boolean);
  Const
       gleich = 'Beide Achsen:';
  Var
    a,b:Integer;
    x1,y1,z1:Longint;
    x2,y2,z2:Longint;
    x3,y3,z3:Longint;
    yfix,zfix: Longint;
    zoomfix: longint;
  Begin
    SetColor(9);
    For a:=1 To GridWidth Do Begin
      For b:=1 To GridHeight Do Begin
        yfix:=real2fix(Feld^[a,b]);
        zfix:=(b-(gridheight div 2+1)) shl 9;
        x1:=(a-(gridwidth div 2+1)) shl 9;
        y1:=fixmul(yfix,fixCos[rotx])-fixmul(zfix,fixSin[Rotx]);
        z1:=fixmul(yfix,fixSin[rotx])+fixmul(zfix,fixCos[Rotx]);

        x2:=fixmul(x1,fixCos[roty])+fixmul(z1,fixSin[roty]);
        y2:=y1;
        z2:=fixmul(-x1,fixSin[roty])+fixmul(z1,fixCos[Roty]);

        x3:=fixmul(x2,fixCos[rotz])-fixmul(y2,fixSin[rotz]);
        y3:=fixmul(x2,fixSin[rotz])+fixmul(y2,fixCos[Rotz]);
        z3:=z2;

        zoomfix:=zoomz shl 9;
        If z3=-Zoomfix then inc(z3);
        Bild^[a,b].x:=fixdiv(x3,(z3+zoomfix)) + 320;
        Bild^[a,b].y:=fixdiv(y3,(z3+Zoomfix)) + 175;
      End;
    End;
    SetColor(1);
    If MaleVert Then Begin
      For a:=1 To GridWidth Do Begin
        For b:=1 To GridHeight Do Begin
          If a < GridWidth Then
             Line(Bild^[a,b].x,Bild^[a,b].y,
                  Bild^[a+1,b].x,Bild^[a+1,b].y);
          If b < GridHeight Then
             Line(Bild^[a,b].x,Bild^[a,b].y,
                  Bild^[a,b+1].x,Bild^[a,b+1].y);
        End;
      End;
    end else begin
      For a:=1 To GridWidth Do Begin
        For b:=1 To GridHeight Do Begin
            PutPixel(Bild^[a,b].x,Bild^[a,b].y,yellow);
        End;
      End;
    End;
    If mode=mode_selecten Then Begin
       Setcolor(9);
       For a:=1 to GridWidth Do Begin
           For b:=1 To GridHeight Do Begin
               If Select^[a,b] Then Rectangle(Bild^[a,b].x-1,Bild^[a,b].y-1,Bild^[a,b].x+2,Bild^[a,b].y+2);
           End;
       End;
    End;
    SetColor(15);
    Rectangle(Bild^[xySelect.x,xySelect.y].x-1,
              Bild^[xySelect.x,xySelect.y].y-1,
              Bild^[xySelect.x,xySelect.y].x+2,
              Bild^[xySelect.x,xySelect.y].y+2);
    If Follow_On Then Outtextxy(1,316,'Vertex-Folgen: AN') Else
       Outtextxy(1,316,'Vertex-Folgen: AUS');
    If Gleichzeitig Then Outtextxy(630-textwidth(gleich+' AN'),316,gleich+' AN') Else
       Outtextxy(630-textwidth(gleich+' AUS'),316,gleich+' AUS');
  End;

Procedure Parabel(VerschX,VerschY,VerschZ,BreiteX,BreiteZ:Real;
                  Rotx,Roty,Rotz:Integer;
                  Berechne_Feld:Boolean);
  Var
    Oldx,Oldy:Integer;
    x,z,Wert:Real;
    a,b:Integer;
    x1,y1,z1:Longint;
    x2,y2,z2:Longint;
    x3,y3,z3:Longint;
    _wert: longint;
    _z: longint;
    zoomfix: longint;
  Begin
    If Berechne_Feld Then Begin
      For b:= (-GridHeight div 2) To (GridHeight div 2) Do Begin
        For a:= (-GridWidth div 2) To (GridWidth div 2) Do Begin
          Wert:=BreiteX*(a+VerschX)*(a+VerschX)+BreiteZ*(b+VerschZ)*(b+VerschZ)+VerschY;
          If wert < 3 then begin
             If Plus_Minus And (Wert < Feld^[a+(gridwidth div 2+1),b+(gridheight div 2+1)]) Then
               Feld^[a+(gridwidth div 2+1),b+(gridheight div 2+1)]:=Wert;
             If (Not Plus_Minus) And (-Wert+6 > Feld^[a+(gridwidth div 2+1),b+(gridheight div 2+1)]) Then
               Feld^[a+(gridwidth div 2+1),b+(gridheight div 2+1)]:=-Wert+6;
          End;
        End;
      End;
    End;

    z:=-GridHeight / 2;
    Repeat
      x:=-GridWidth / 2;
      Repeat
        X:=X+GenauigkeitderParabel;
        Wert:=BreiteX*(x+VerschX)*(x+VerschX)+BreiteZ*(Z+VerschZ)*(Z+VerschZ)+VerschY;
        _wert:=real2fix(wert);

        If Wert < 3 Then Begin
          _z:=real2fix(z);
          x1:=real2fix(x);
          if plus_minus then begin
             y1:=fixmul(_Wert,fixCos[rotx])-fixmul(_z,fixSin[Rotx]);
             z1:=fixmul(_Wert,fixSin[rotx])+fixmul(_z,fixCos[Rotx]);
          end else begin
             y1:=fixmul(-_Wert+2*1536,fixCos[rotx])-fixmul(_z,fixSin[Rotx]);
             z1:=fixmul(-_Wert+2*1536,fixSin[rotx])+fixmul(_z,fixCos[Rotx]);
          end;
          x2:=fixmul(x1,fixcos[roty])+fixmul(z1,fixsin[roty]);
          y2:=y1;
          z2:=fixmul(-x1,fixsin[roty])+fixmul(z1,fixcos[Roty]);

          x3:=fixmul(x2,fixcos[rotz])-fixmul(y2,fixsin[rotz]);
          y3:=fixmul(x2,fixsin[rotz])+fixmul(y2,fixcos[Rotz]);
          z3:=z2;

          zoomfix:=zoomz shl 9;
          If z3=-Zoomfix then inc(z3);
          a:=fixdiv(x3,(z3+zoomfix));
          b:=fixdiv(y3,(z3+Zoomfix));

          PutPixel(a+320,b+175,15);
        End;
      Until X>=GridWidth / 2-1;
      Z:=z+GenauigkeitderParabel;
    Until Z>=GridHeight / 2-1;
  End;

procedure incr(var zahl: real; faktor: real);
begin
     zahl:=zahl+faktor;
end;

Procedure Verschieben(x,y,z: real);
Begin
     incr(vx,x);
     incr(vy,y);
     incr(vz,z);
End;

Procedure Drehen(x,y,z: integer);
  Begin
     inc(rotx,x);
     inc(roty,y);
     inc(rotz,z);
     if rotx >= 359 then rotx:=rotx-360;
     if roty >= 359 then roty:=roty-360;
     if rotz >= 359 then rotz:=rotz-360;
     if rotx < 0 then rotx:=360;
     if roty < 0 then roty:=360;
     if rotz < 0 then rotz:=360;
  End;

Procedure Selecten(x,y:Integer);
  Begin
    Inc(xySelect.x,x);
    Inc(xySelect.y,y);
    If xySelect.x <1 Then xySelect.x:=1;
    If xySelect.y <1 Then xySelect.y:=1;
    If xySelect.x > GridWidth Then xySelect.x:=GridWidth;
    If xySelect.y > GridHeight Then xySelect.y:=GridHeight;
  End;

Procedure CoolFeature(x,y: Word; IncFirst,IncNext,DecFactor: Real);
Var
   a,b,DiffX,DiffY: Word;
   Distance,IncY: Real;
   IncFactor: Real;
Begin
     Incr(Feld^[x,y],IncFirst);
     If IncFirst > 0 Then Begin
        For a:=1 To GridWidth Do Begin
            For b:=1 To GridHeight Do Begin
                If Not ((a = x) And (b = y)) Then Begin
                   DiffX:=abs(x-a);
                   DiffY:=abs(y-b);
                   Distance:=Sqrt(DiffX*DiffX+DiffY*DiffY);
                   IncFactor:=IncNext-(Distance*DecFactor);
                   If IncFactor > 0 Then Begin
                      IncY:=IncFirst*IncFactor;
                      If ((Feld^[a,b]+IncY) < Feld^[x,y]) Then Incr(Feld^[a,b],IncY);
                   End;
                End;
            End;
        End;
     End Else Begin
        For a:=1 To GridWidth Do Begin
            For b:=1 To GridHeight Do Begin
                If Not ((a = x) And (b = y)) Then Begin
                   DiffX:=abs(x-a);
                   DiffY:=abs(y-b);
                   Distance:=Sqrt(DiffX*DiffX+DiffY*DiffY);
                   IncFactor:=IncNext-(Distance*DecFactor);
                   If IncFactor > 0 Then Begin
                      IncY:=IncFirst*IncFactor;
                      If ((Feld^[a,b]+IncY) > Feld^[x,y]) Then Incr(Feld^[a,b],IncY);
                   End;
                End;
            End;
        End;
     End;
End;

Procedure IncVerts(x:Real);
  Var
    a,b:Integer;
  Begin
    If Follow_On Then Begin
       For a:=1 To GridWidth Do
         For b:=1 To GridHeight Do
           If Select^[a,b] Then CoolFeature(a,b,x,IncNext,DecFactor);
       If (Not Select^[xySelect.x,xySelect.y]) Then
         CoolFeature(xySelect.x,xySelect.y,x,IncNext,DecFactor);
    End Else Begin
       For a:=1 To GridWidth Do
         For b:=1 To GridHeight Do
           If Select^[a,b] Then Incr(Feld^[a,b],x);
       If (Not Select^[xySelect.x,xySelect.y]) Then
         Incr(Feld^[xySelect.x,xySelect.y],x);
    End;
  End;

Procedure Draw3DBox(X1,Y1,X2,Y2: INteger);
Begin
  SetColor(White);
  Line(X1,Y1,X2,Y1);
  Line(X1,Y1,X1,Y2);
  SetColor(DarkGray);
  Line(X2,Y1,X2,Y2);
  Line(X1,Y2,X2,Y2);
  SetColor(Black);
  RectAngle(X1-1,Y1-1,X2+1,Y2+1);
End;

Procedure Draw3DBox2(X1,Y1,X2,Y2: INteger);
Begin
  SetColor(DarkGray);
  Line(X1,Y1,X2,Y1);
  Line(X1,Y1,X1,Y2);
  SetColor(White);
  Line(X2,Y1,X2,Y2);
  Line(X1,Y2,X2,Y2);
  SetColor(Black);
  RectAngle(X1+1,Y1+1,X2-1,Y2-1);
End;

Function getCentered(X1,X2,Width: Integer): Integer;
Begin
  getCentered:=(X1+(((X2-X1)-Width) div 2));
End;

Procedure ZeichneRahmen;
const
     left = '[Alt]-H fr Hilfe';
     headline = '3D-Landscape v1.0';
Begin
     setviewport(0,0,639,349,true);
     setcolor(white);
     rectangle(0,0,639,349);
     setcolor(lightgray);
     rectangle(1,1,638,348);
     setfillstyle(1,7);
     bar(3,3,636,20);
     setcolor(white);
     line(2,19,637,19);
     draw3dbox(4,3,150,17);
     draw3dbox(153,3,484,17);
     draw3dbox(487,3,636,17);
     settextstyle(defaultfont,horizdir,1);
     outtextxy(getcentered(0,639,textwidth(headline)),7,headline);
     outtextxy(getcentered(0,150,textwidth(left)),7,left);
     outtextxy(getcentered(487,636,textwidth(status[mode])),7,status[mode]);
     setcolor(black);
     line(2,18,637,18);
     rectangle(2,21,637,347);
     setviewport(3,22,636,346,true);
End;

Procedure MaleDesktop;
Begin
     ZeichneRahmen;
     swapAP;
     ZeichneRahmen;
     swapAP;
End;

Function PrintInfo(Information: String): Char;
Var
  _X1,_Y1,_X2,_Y2: Integer;
  SnapShoot: Pointer;
  SnapSize: Word;
  sack: viewporttype;
Begin
  getviewsettings(sack);
  setviewport(0,0,getmaxx,getmaxy,true);
  SetTextStyle(DefaultFont,HorizDir,1);
  _X1:=GetCentered(0,639,TextWidth(Information)+20);
  _Y1:=GetCentered(0,349,TextHeight(Information)+20);
  _X2:=_X1+TextWidth(Information)+20;
  _Y2:=_Y1+TextHeight(Information)+20;
  SnapSize:=ImageSize(_X1,_Y1,_X2,_Y2);
  If MaxAvail < SnapSize then halt(2);
  GetMem(SnapShoot,SnapSize);
  GetImage(_X1-1,_Y1-1,_X2+1,_Y2+1,SnapShoot^);
  Draw3DBox(_X1,_Y1,_X2,_Y2);
  SetFillStyle(1,7);
  Bar(_X1+1,_Y1+1,_X2-1,_Y2-1);
  OutTextXY(_X1+10,_Y1+10,Information);
  Repeat until Keypressed;
  PrintInfo:=ReadKey;
  PutImage(_X1-1,_Y1-1,SnapShoot^,Normalput);
  FreeMem(SnapShoot,SnapSize);
  setviewport(sack.x1,sack.y1,sack.x2,sack.x2,sack.clip);
  MaleDesktop;
End;

FUNCTION INPUTLINE(X1,Y1,X2,Y2: INTEGER; INFORMATION,VORGABE: STRING): STRING;
VAR
   sack: viewporttype;
   ZEICHEN: CHAR;
   SNAPSHOOT: POINTER;
   SNAPSIZE :WORD;
   THEINPUT: STRING;
   HEIGHT_BOX,WIDTH_BOX: INTEGER;
BEGIN
     getviewsettings(sack);
     setviewport(0,0,getmaxx,getmaxy,true);
     SETTEXTSTYLE(DEFAULTFONT,HORIZDIR,1);
     HEIGHT_BOX:=TEXTHEIGHT(INFORMATION)+10;
     WIDTH_BOX:=X2-X1-10;
     THEINPUT:=VORGABE;
     SNAPSIZE:=ImageSize(X1,Y1,X2,Y2);
     IF SNAPSIZE > MAXAVAIL THEN halt(2);
     GETMEM(SNAPSHOOT,SNAPSIZE);
     GETIMAGE(X1,Y1,X2,Y2,SNAPSHOOT^);
     SETFILLSTYLE(1,7);
     BAR(X1,Y1,X2,Y2);
     DRAW3DBOX(X1+1,Y1+1,X2-1,Y2-1);
     OUTTEXTXY(X1+5,Y1+5,INFORMATION);
     DRAW3DBOX2(X1+4,Y2-HEIGHT_BOX-6,X2-4,Y2-4);
     SETFILLSTYLE(1,RED);
     BAR(X1+6,Y2-HEIGHT_BOX-4,X2-6,Y2-6);
     SETCOLOR(WHITE);
     OUTTEXTXY(X1+7,Y2-HEIGHT_BOX+1,THEINPUT+'_');
     REPEAT
           ZEICHEN:=READKEY;
                      IF (((ZEICHEN <> #8) AND (ZEICHEN <> #13)) AND (ZEICHEN <> #27)) THEN BEGIN
                         IF TEXTWIDTH(THEINPUT+'  ') < WIDTH_BOX THEN BEGIN
                            IF ZEICHEN IN ['!'..'^',' ','a'..'z','A'..'Z','-',',','.','1'..'0'] THEN
                               THEINPUT:=THEINPUT+ZEICHEN;
                         END;
                      END;
                      IF ZEICHEN = #8 THEN BEGIN
                         IF LENGTH(THEINPUT) > 1 THEN BEGIN
                            THEINPUT:=COPY(THEINPUT,0,LENGTH(THEINPUT)-1);
                         END ELSE THEINPUT:='';
                      END;
                      IF ZEICHEN = #27 THEN THEINPUT:='';
           SETFILLSTYLE(1,RED);
           BAR(X1+6,Y2-HEIGHT_BOX-4,X2-6,Y2-6);
           SETCOLOR(WHITE);
           OUTTEXTXY(X1+7,Y2-HEIGHT_BOX+1,THEINPUT+'_');
     UNTIL ZEICHEN IN [#27,#13];
     PUTIMAGE(X1,Y1,SNAPSHOOT^,NORMALPUT);
     FREEMEM(SNAPSHOOT,SNAPSIZE);
     INPUTLINE:=THEINPUT;
     SETCOLOR(BLACK);
     setviewport(sack.x1,sack.y1,sack.x2,sack.x2,sack.clip);
     MaleDesktop;
END;

function FileExists(FileName: String): Boolean;
var
  F: file;
begin
     {$I-}
     Assign(F, FileName);
     Reset(F);
     Close(F);
     {$I+}
     FileExists := (IOResult = 0) and (FileName <> '');
end;

Procedure SaveSCP;
var
   f: file;
   filename: string;
   ch: char;
begin
    filename:=inputline(50,100,590,145,'Speichern in (*.SCP wird angehngt):','');
    if filename = '' then exit;
    if pos('.',filename)=0 then filename:=filename+'.SCP';
    if FileExists(filename) then begin
       ch:=Upcase(printinfo(filename+' existiert schon. berschreiben? [j/n]'));
       if not (ch = 'J') then exit;
    end;
    Assign(F, filename);
    {$I-}
    Rewrite(F,1);
    {$I+}
    if IOResult <> 0 then begin
       ch:=printinfo('Fehler beim erzeugen von '+filename+'!');
       exit;
    end;
{    write(f,feld^);}
    seek(f,0);
    blockwrite(f,gridwidth,2);
    blockwrite(f,gridheight,2);
    blockwrite(f,feld^,gridlengs*gridbreite*6);
    close(f);
end;

Procedure Init_Vars;
  Var
    a,b:Integer;
    counter: word;
  Begin
    Gleichzeitig:=True;
    IncNext_Str:='99';
    DecFactor_Str:='10';
    IncNext:=0.99;
    DecFactor:=0.1;
    Follow_on:=True;
    Randomize;
    GenauigkeitderParabel:=0.607;
    plus_minus:=true;
    breiteX:=0.4;
    breiteZ:=0.4;
    mode:=mode_verschieben;
    make_tabelle;
    counter:=1;
    zoomz:=180;
    rotx:=0;
    roty:=0;
    rotz:=0;
    vx:=0;
    vy:=-2;
    vz:=0;
    lines:=true;
    For b:=1 To GridHeight Do
      For a:=1 To GridWidth Do Begin
        Feld^[a,b]:=3;
        Select^[a,b]:=False;
      End;
    For b:=1 To Gridlengs Do
      For a:=1 To Gridbreite Do Begin
        Feld^[a,b]:=3;
        Select^[a,b]:=False;
      End;
    xySelect.x:=1;
    xySelect.y:=1;
  End;

procedure LoadSCP;
var
   f: file;
   filename: string;
   ch: char;
   doedel: word;
begin
    filename:=inputline(50,100,590,145,'Laden aus (*.SCP wird angehngt):','');
    if filename = '' then exit;
    if pos('.',filename)=0 then filename:=filename+'.SCP';
    if not fileexists(filename) then begin
       ch:=printinfo(filename+' nicht gefunden!');
       exit;
    end;
    ch:=printinfo('Alle Daten werden berschrieben. Fortfahren? [j/n]');
    if not (ch in ['j','J']) then exit;
    init_vars;
    assign(f,filename);
    reset(f,1);
    {$I-}
{    read(f,feld^);}
    blockread(f,gridwidth,2);
    blockread(f,gridheight,2);
    blockread(f,feld^,gridlengs*gridbreite*6);
    {$I+}
    if IOResult <> 0 then begin
       close(f);
       ch:=printinfo('Fehler beim Laden aus '+filename+'!');
       exit;
    end;
    close(f);

    if gridwidth > gridheight then doedel:=gridwidth else doedel:=gridheight;
    Case doedel of
      2..10:ZoomZ:=20;
      11..20:ZoomZ:=30;
      21..30:ZoomZ:=40;
      31..40:ZoomZ:=60;
      41..60:ZoomZ:=70;
      61..70:ZoomZ:=180;
      71..80:ZoomZ:=200;
      81..90:ZoomZ:=220;
    End;
    maxzoom:=zoomz+600;
    minzoom:=zoomz-10;
end;

Procedure NewSCP;
var
   ch: char;
   Joe:String;
   Breite,Lengs:Byte;
   Code:Word;
   doedel: byte;
Begin
     ch:=printinfo('Alle Daten werden gelscht! Fortfahren? [j/n]');
     if not (ch in ['J','j']) then exit;

     Repeat
       Joe:=inputline(180,100,420,150,' Breite des Gitters(2..100)','');
       if Joe = '' then exit;
       val(Joe,Breite,code);
     Until Breite In [2..100];

     Repeat
       Joe:=inputline(180,100,420,150,' Lnge des Gitters(2..100)','');
       if Joe = '' then exit;
       val(Joe,Lengs,code);
     Until Lengs In [2..100];

     gridwidth:=breite;
     gridheight:=lengs;
     init_vars;

     if breite > lengs then doedel:=breite else doedel:=lengs;
     Case doedel of
       2..10:ZoomZ:=20;
       11..20:ZoomZ:=30;
       21..30:ZoomZ:=40;
       31..40:ZoomZ:=60;
       41..60:ZoomZ:=70;
       61..70:ZoomZ:=180;
       71..80:ZoomZ:=200;
       81..90:ZoomZ:=220;
     End;
     maxzoom:=zoomz+600;
     minzoom:=zoomz-10;
     maleDesktop;
End;

Procedure SaveASC;
  Var
    m:real;
    F: Text;
    c:LongInt;
    k,h:String;
    i,count:integer;
    Counter:Integer;
    Sack,a,b,Smooth:Integer;
    ch: char;
    filename: string;
    maxgrid,maxface: word;
  Begin
    Sack:=0;
    Smooth:=1;
    filename:=inputline(50,100,590,145,'Exportieren nach (*.ASC wird angehngt):','');
    if filename = '' then exit;
    if pos('.',filename)=0 then filename:=filename+'.ASC';
    if FileExists(filename) then begin
       ch:=printinfo(filename+' existiert schon. berschreiben? [j/n]');
       if not (ch in ['J','j']) then exit;
    end;
    Assign(F, filename);
    {$I-}
    Rewrite(F);
    {$I+}
    if IOResult <> 0 then begin
       ch:=printinfo('Fehler beim erzeugen von '+filename+'!');
       exit;
    end;
    maxgrid:=gridwidth*gridheight;
    maxface:=(Gridwidth-1)*(Gridheight-1)*2;;
    Writeln(F,'Named object: "Grid"');
    Writeln(F,'Tri-mesh, Vertices: '+Stri(MaxGrid)+'  Faces: '+Stri(MaxFace));
    Writeln(F,'Vertex list:');

    For a:=1 To GridWidth Do Begin
      For b:=1 To GridHeight Do Begin
        h:='';
        count:=0;
        m:=Feld^[a,b];
        c:=Round(m*10000000);
        k:=stri(c);
        For i:=Length(k) DownTo 1 Do begin
          If k[i] <> '-' Then
            h:=k[i]+h
          Else If (m<1) And
                  (m>-1) then h:='0'+h;
          If Count=5 then h:='.'+h;
          Inc(Count);
        End;
        If Count=6 Then  begin
          h:='0'+h;
          Inc(Count);
        End;
        If Count<7 then begin
          For i:=6-Count downto 1 Do
            h:='0'+h;
          h:='0.'+h;
        End;
        if m<0 then h:='-'+h;

        Writeln(F,'Vertex '+Stri(Sack)+':  X: '+
                  Stri(a*10)+'.000000   Y: '+h+
                  '   Z: '+Stri(b*10)+'.000000');
        Inc(Sack);
      End;
    End;

    Count:=0;
    Writeln(F,'Face list:');
    For a:=1 To GridWidth-1 Do Begin
      For b:=1 To GridHeight-1 Do Begin
        WriteLn(F,'Face '+Stri(Count)+':  '+
                  'A:'+Stri(((a-1)*GridWidth)+b)+
                 ' B:'+Stri(((a-1)*GridWidth)+b-1)+
                 ' C:'+Stri(((a)*GridWidth)+b-1)+
                ' AB:1 BC:1 CA:0');
        Inc(Count);
{        WriteLn(F,'Smoothing:  '+Stri(Smooth));}
        WriteLn(F,'Face '+Stri(Count)+':  '+
                  'A:'+Stri(((a)*GridWidth)+b)+
                 ' B:'+Stri(((a-1)*GridWidth)+b)+
                 ' C:'+Stri(((a)*GridWidth)+b-1)+
                ' AB:1 BC:0 CA:1');
        Inc(Smooth);
{        WriteLn(F,'Smoothing:  '+Stri(Smooth));}
        Inc(Count);
        Inc(Smooth);
        If Smooth >= 31 then Smooth:=1;
      End;
    End;
{Face 0:    A:0 B:1 C:2 AB:1 BC:1 CA:0}
    Close(F);
  End;

Procedure programm_ende;
var
   antwort: char;
Begin
     antwort:=printinfo('Programm beenden? [j/n]');
     if antwort in ['J','j'] then begin
        leaveVGA;
        halt;
     end;
     MaleDesktop;
End;

Procedure Hilfe;
Var
   sack: viewporttype;
   f: text;
   zeile: string;
   akt_y: word;
   ch: char;
   Letztes: Boolean;
Begin
     assign(f,hilfeDatei);
     {$I-}
     reset(f);
     {$I+}
     If IOResult <> 0 then exit;
     settextstyle(defaultfont,horizdir,1);
     getviewsettings(sack);
     setviewport(0,0,getmaxx,getmaxy,true);
     Letztes:=False;
     Repeat
           setcolor(lightgray);
           setfillstyle(1,7);
           bar(0,0,639,349);
           draw3dbox(10,10,629,339);
           akt_y:=15;
           while (not eof(f)) do begin
                 readln(f,zeile);
                 outtextxy(25,akt_y,zeile);
                 inc(akt_y,9);
                 If Eof(F) Then letztes:=True;
                 If akt_y >= 320 then break;
           end;
           ch:=readkey;
     Until (ch = #27) Or Letztes;
     close(f);
     setviewport(sack.x1,sack.y1,sack.x2,sack.x2,sack.clip);
     MaleDesktop;
End;

Procedure MakeRandomMap;
  Var
    i:Integer;
    VerschiebX,VerschiebY,VerschiebZ,BreiteX,BreiteZ:Real;
    Berge: Word;
    Berg_str: string;
    code: integer;
  Begin
    berg_str:=inputline(180,100,420,150,'Anzahl der Berge? (1..65532)','');
    val(berg_str,berge,code);
    settextstyle(defaultfont,horizdir,2);
    setfillstyle(1,black);
    For i:=1 To Berge Do Begin
      bar(0,0,textwidth(Stri(i)),textheight(Stri(i)));
      setcolor(white);
      Outtextxy(0,0,Stri(i));
      VerschiebX:=Random(GridWidth)-(GridWidth / 2);
      VerschiebZ:=Random(GridHeight)-(GridHeight / 2);
      VerschiebY:=-Random(10)+2;
      BreiteX:=pi / (Random(20)+1);
      BreiteZ:=pi / (Random(20)+1);
      Parabel(VerschiebX,VerschiebY,VerschiebZ,BreiteX,BreiteZ,
              Rotx,Roty,Rotz,True);
    End;
  End;

Function Value(Str: String): Real;
Var
   tmp: Real;
   code: word;
Begin
     Val(Str,tmp,Code);
     Value:=Tmp;
End;

Procedure SetParameters;
Var
   Joe: String;
   Prozent: Real;
Begin
     Repeat
           Joe:=Inputline(100,100,550,140,'Nchsten Vertex verndern um wieviel Prozent? (1-100)',IncNext_Str);
           If Joe = '' Then Exit;
           Prozent:=Value(Joe);
     Until (Prozent > 0) And (Prozent <= 100);
     IncNext_Str:=Joe;
     IncNext:=Prozent / 100;
     Repeat
           Joe:=Inputline(100,100,550,140,'Dann dekrementieren um wieviel Prozent? (1-99)',DecFactor_Str);
           If Joe = '' Then Exit;
           Prozent:=Value(Joe);
     Until (Prozent > 0) And (Prozent < 100);
     DecFactor:=Prozent / 100;
     DecFactor_Str:=Joe;
End;

Begin
  initVGA;
  new(Feld);
  new(Bild);
  new(Select);
  Init_Vars;
  MaleDesktop;
  ch:=#0;
  zoomz:=200;
  gridwidth:=30;
  gridheight:=30;
  maxzoom:=150;
  minzoom:=20;
  zoomz:=30;
  repeat
      swapAP;
      ClearViewPort;
      male_feld(rotx,roty,rotz,lines);
      If Mode=Mode_verschieben Then
        Parabel(vx,vy,vz,breiteX,breiteZ,rotx,roty,rotz,False);
      swapVP;
      delkeybuffer;
      ch:=Upcase(readkey);
      case ch of
           #9: plus_minus:= not plus_minus;
           '/': If Mode=mode_verschieben Then
                   If Gleichzeitig Then Begin
                      incr(breiteZ,BreiteZ*0.5);
                      incr(breiteX,BreiteX*0.5);
                   End Else incr(breiteZ,BreiteZ*0.5);
           '*': If Mode=mode_verschieben Then
                   If Gleichzeitig Then Begin
                      incr(breiteZ,BreiteZ*-0.2);
                      incr(breiteX,BreiteX*-0.2);
                   End Else incr(breiteZ,BreiteZ*-0.2);
           '-': Case Mode Of
                  mode_verschieben: Begin
                   If Gleichzeitig Then Begin
                      incr(breiteZ,BreiteZ*0.5);
                      incr(breiteX,BreiteX*0.5);
                   End Else incr(breiteX,BreiteX*0.5);
                  End;
                  mode_drehen: Inc(ZoomZ,5);
                  mode_Selecten: IncVerts(+0.25);
                End;
           '+': Case Mode Of
                  mode_verschieben: Begin
                   If Gleichzeitig Then Begin
                      incr(breiteZ,BreiteZ*-0.2);
                      incr(breiteX,BreiteX*-0.2);
                   End Else incr(breiteX,BreiteX*-0.2);
                  End;
                  mode_drehen: Inc(ZoomZ,-5);
                  mode_Selecten: IncVerts(-0.25);
                End;
           'D': If Mode=mode_Selecten Then Unselect;
           'M': If Mode=mode_Selecten Then SelectAll;
           'F': Follow_on:=Not Follow_On;
           'G': Gleichzeitig:=Not Gleichzeitig;
           #13: If Mode=Mode_verschieben Then
                  Parabel(vx,vy,vz,breiteX,BreiteZ,rotx,roty,rotz,True);
           #32: If Mode=Mode_selecten Then
                  Select^[xySelect.x,xySelect.y]:=Not Select^[xySelect.x,xySelect.y];
           #27: programm_ende;
      end;
      if ZoomZ<minzoom then ZoomZ:=minzoom;
      if ZoomZ>maxzoom then ZoomZ:=maxzoom;
      if ch = #0 then begin
         ch:=readkey;
         case ch of
              #18: saveASC;
              #31: saveSCP;
              #35: hilfe;
              #38: loadSCP;
              #49: newSCP;
              #63: MakeRandomMap;
              #64: SetParameters;
              #59: begin mode:=mode_verschieben; MaleDesktop; end;
              #60: begin mode:=mode_drehen; MaleDesktop; end;
              #61: begin mode:=mode_selecten; MaleDesktop; end;
              #62: lines:=not lines;
              #72: case mode of
                        mode_verschieben: verschieben(0,0,-0.5);
                        mode_drehen: drehen(5,0,0);
                        mode_selecten: selecten(0,1);
                   end;
              #80: case mode of
                        mode_verschieben: verschieben(0,0,0.5);
                        mode_drehen: drehen(-5,0,0);
                        mode_selecten: selecten(0,-1);
                   end;
              #75: case mode of
                        mode_verschieben: verschieben(0.5,0,0);
                        mode_drehen: drehen(0,5,0);
                        mode_selecten: selecten(-1,0);
                   end;
              #77: case mode of
                        mode_verschieben: verschieben(-0.5,0,0);
                        mode_drehen: drehen(0,-5,0);
                        mode_selecten: selecten(1,0);
                   end;
              #73: case mode of
                        mode_verschieben: verschieben(0,-0.5,0);
                        mode_drehen: drehen(0,0,5);
                   end;
              #81: case mode of
                        mode_verschieben: verschieben(0,0.5,0);
                        mode_drehen: drehen(0,0,-5);
                   end;
         end;
      end;
  until false;
  LeaveVGA;
End.